/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Error;
import com.squareup.connect.models.InventoryCount;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * 
 */
@ApiModel(description = "")

public class BatchChangeInventoryResponse {
  @JsonProperty("errors")
  private List<Error> errors = new ArrayList<Error>();

  @JsonProperty("counts")
  private List<InventoryCount> counts = new ArrayList<InventoryCount>();

  public BatchChangeInventoryResponse errors(List<Error> errors) {
    this.errors = errors;
    return this;
  }

  public BatchChangeInventoryResponse addErrorsItem(Error errorsItem) {
    this.errors.add(errorsItem);
    return this;
  }

   /**
   * Any errors that occurred during the request.
   * @return errors
  **/
  @ApiModelProperty(value = "Any errors that occurred during the request.")
  public List<Error> getErrors() {
    return errors;
  }

  public void setErrors(List<Error> errors) {
    this.errors = errors;
  }

  public BatchChangeInventoryResponse counts(List<InventoryCount> counts) {
    this.counts = counts;
    return this;
  }

  public BatchChangeInventoryResponse addCountsItem(InventoryCount countsItem) {
    this.counts.add(countsItem);
    return this;
  }

   /**
   * The current counts for all objects referenced in the request.
   * @return counts
  **/
  @ApiModelProperty(value = "The current counts for all objects referenced in the request.")
  public List<InventoryCount> getCounts() {
    return counts;
  }

  public void setCounts(List<InventoryCount> counts) {
    this.counts = counts;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BatchChangeInventoryResponse batchChangeInventoryResponse = (BatchChangeInventoryResponse) o;
    return Objects.equals(this.errors, batchChangeInventoryResponse.errors) &&
        Objects.equals(this.counts, batchChangeInventoryResponse.counts);
  }

  @Override
  public int hashCode() {
    return Objects.hash(errors, counts);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BatchChangeInventoryResponse {\n");
    
    sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
    sb.append("    counts: ").append(toIndentedString(counts)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

