/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * An image file to use in Square catalogs. Can be associated with catalog items, item variations, and categories.
 */
@ApiModel(description = "An image file to use in Square catalogs. Can be associated with catalog items, item variations, and categories.")

public class CatalogImage {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("url")
  private String url = null;

  @JsonProperty("caption")
  private String caption = null;

  public CatalogImage name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The internal name of this image. Identifies this image in calls to the Connect APIs.
   * @return name
  **/
  @ApiModelProperty(value = "The internal name of this image. Identifies this image in calls to the Connect APIs.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public CatalogImage url(String url) {
    this.url = url;
    return this;
  }

   /**
   * The URL of this image. Generated by Square after an image is uploaded to the CreateCatalogImage endpoint.
   * @return url
  **/
  @ApiModelProperty(value = "The URL of this image. Generated by Square after an image is uploaded to the CreateCatalogImage endpoint.")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public CatalogImage caption(String caption) {
    this.caption = caption;
    return this;
  }

   /**
   * A caption that describes what is shown in the image. Displayed in the Square Online Store.
   * @return caption
  **/
  @ApiModelProperty(value = "A caption that describes what is shown in the image. Displayed in the Square Online Store.")
  public String getCaption() {
    return caption;
  }

  public void setCaption(String caption) {
    this.caption = caption;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CatalogImage catalogImage = (CatalogImage) o;
    return Objects.equals(this.name, catalogImage.name) &&
        Objects.equals(this.url, catalogImage.url) &&
        Objects.equals(this.caption, catalogImage.caption);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, url, caption);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CatalogImage {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    caption: ").append(toIndentedString(caption)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

