/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * Retrieve a paged-list of employees for a Square account
 */
@ApiModel(description = "Retrieve a paged-list of employees for a Square account")

public class ListEmployeesRequest {
  @JsonProperty("location_id")
  private String locationId = null;

  /**
   * Specifies the EmployeeStatus to filter the employee by. See [EmployeeStatus](#type-employeestatus) for possible values
   */
  public enum StatusEnum {
    ACTIVE("ACTIVE"),
    
    INACTIVE("INACTIVE");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  @JsonProperty("limit")
  private Integer limit = null;

  @JsonProperty("cursor")
  private String cursor = null;

  public ListEmployeesRequest locationId(String locationId) {
    this.locationId = locationId;
    return this;
  }

   /**
   * Filter employees returned to only those that are associated with the specified location.
   * @return locationId
  **/
  @ApiModelProperty(value = "Filter employees returned to only those that are associated with the specified location.")
  public String getLocationId() {
    return locationId;
  }

  public void setLocationId(String locationId) {
    this.locationId = locationId;
  }

  public ListEmployeesRequest status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * Specifies the EmployeeStatus to filter the employee by. See [EmployeeStatus](#type-employeestatus) for possible values
   * @return status
  **/
  @ApiModelProperty(value = "Specifies the EmployeeStatus to filter the employee by. See [EmployeeStatus](#type-employeestatus) for possible values")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public ListEmployeesRequest limit(Integer limit) {
    this.limit = limit;
    return this;
  }

   /**
   * The number of employees to be returned on each page.
   * @return limit
  **/
  @ApiModelProperty(value = "The number of employees to be returned on each page.")
  public Integer getLimit() {
    return limit;
  }

  public void setLimit(Integer limit) {
    this.limit = limit;
  }

  public ListEmployeesRequest cursor(String cursor) {
    this.cursor = cursor;
    return this;
  }

   /**
   * The token required to retrieve the specified page of results.
   * @return cursor
  **/
  @ApiModelProperty(value = "The token required to retrieve the specified page of results.")
  public String getCursor() {
    return cursor;
  }

  public void setCursor(String cursor) {
    this.cursor = cursor;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ListEmployeesRequest listEmployeesRequest = (ListEmployeesRequest) o;
    return Objects.equals(this.locationId, listEmployeesRequest.locationId) &&
        Objects.equals(this.status, listEmployeesRequest.status) &&
        Objects.equals(this.limit, listEmployeesRequest.limit) &&
        Objects.equals(this.cursor, listEmployeesRequest.cursor);
  }

  @Override
  public int hashCode() {
    return Objects.hash(locationId, status, limit, cursor);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ListEmployeesRequest {\n");
    
    sb.append("    locationId: ").append(toIndentedString(locationId)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    limit: ").append(toIndentedString(limit)).append("\n");
    sb.append("    cursor: ").append(toIndentedString(cursor)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

