/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Money;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * A rounding adjustment of the money being returned. Commonly used to apply Cash Rounding when the minimum unit of account is smaller than the lowest physical denomination of currency.
 */
@ApiModel(description = "A rounding adjustment of the money being returned. Commonly used to apply Cash Rounding when the minimum unit of account is smaller than the lowest physical denomination of currency.")

public class OrderRoundingAdjustment {
  @JsonProperty("uid")
  private String uid = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("amount_money")
  private Money amountMoney = null;

  public OrderRoundingAdjustment uid(String uid) {
    this.uid = uid;
    return this;
  }

   /**
   * Unique ID that identifies the rounding adjustment only within this order.  This field is read-only.
   * @return uid
  **/
  @ApiModelProperty(value = "Unique ID that identifies the rounding adjustment only within this order.  This field is read-only.")
  public String getUid() {
    return uid;
  }

  public void setUid(String uid) {
    this.uid = uid;
  }

  public OrderRoundingAdjustment name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The name of the rounding adjustment from the original sale Order.
   * @return name
  **/
  @ApiModelProperty(value = "The name of the rounding adjustment from the original sale Order.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public OrderRoundingAdjustment amountMoney(Money amountMoney) {
    this.amountMoney = amountMoney;
    return this;
  }

   /**
   * Actual rounding adjustment amount.
   * @return amountMoney
  **/
  @ApiModelProperty(value = "Actual rounding adjustment amount.")
  public Money getAmountMoney() {
    return amountMoney;
  }

  public void setAmountMoney(Money amountMoney) {
    this.amountMoney = amountMoney;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    OrderRoundingAdjustment orderRoundingAdjustment = (OrderRoundingAdjustment) o;
    return Objects.equals(this.uid, orderRoundingAdjustment.uid) &&
        Objects.equals(this.name, orderRoundingAdjustment.name) &&
        Objects.equals(this.amountMoney, orderRoundingAdjustment.amountMoney);
  }

  @Override
  public int hashCode() {
    return Objects.hash(uid, name, amountMoney);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class OrderRoundingAdjustment {\n");
    
    sb.append("    uid: ").append(toIndentedString(uid)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    amountMoney: ").append(toIndentedString(amountMoney)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

