/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Card;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * Represents additional details of a tender with &#x60;type&#x60; &#x60;CARD&#x60; or &#x60;SQUARE_GIFT_CARD&#x60;
 */
@ApiModel(description = "Represents additional details of a tender with `type` `CARD` or `SQUARE_GIFT_CARD`")

public class TenderCardDetails {
  /**
   * The credit card payment's current state (such as `AUTHORIZED` or `CAPTURED`). See [TenderCardDetailsStatus](#type-tendercarddetailsstatus) for possible values
   */
  public enum StatusEnum {
    AUTHORIZED("AUTHORIZED"),
    
    CAPTURED("CAPTURED"),
    
    VOIDED("VOIDED"),
    
    FAILED("FAILED");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  @JsonProperty("card")
  private Card card = null;

  /**
   * The method used to enter the card's details for the transaction. See [TenderCardDetailsEntryMethod](#type-tendercarddetailsentrymethod) for possible values
   */
  public enum EntryMethodEnum {
    SWIPED("SWIPED"),
    
    KEYED("KEYED"),
    
    EMV("EMV"),
    
    ON_FILE("ON_FILE"),
    
    CONTACTLESS("CONTACTLESS");

    private String value;

    EntryMethodEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static EntryMethodEnum fromValue(String text) {
      for (EntryMethodEnum b : EntryMethodEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("entry_method")
  private EntryMethodEnum entryMethod = null;

  public TenderCardDetails status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * The credit card payment's current state (such as `AUTHORIZED` or `CAPTURED`). See [TenderCardDetailsStatus](#type-tendercarddetailsstatus) for possible values
   * @return status
  **/
  @ApiModelProperty(value = "The credit card payment's current state (such as `AUTHORIZED` or `CAPTURED`). See [TenderCardDetailsStatus](#type-tendercarddetailsstatus) for possible values")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public TenderCardDetails card(Card card) {
    this.card = card;
    return this;
  }

   /**
   * The credit card's non-confidential details.
   * @return card
  **/
  @ApiModelProperty(value = "The credit card's non-confidential details.")
  public Card getCard() {
    return card;
  }

  public void setCard(Card card) {
    this.card = card;
  }

  public TenderCardDetails entryMethod(EntryMethodEnum entryMethod) {
    this.entryMethod = entryMethod;
    return this;
  }

   /**
   * The method used to enter the card's details for the transaction. See [TenderCardDetailsEntryMethod](#type-tendercarddetailsentrymethod) for possible values
   * @return entryMethod
  **/
  @ApiModelProperty(value = "The method used to enter the card's details for the transaction. See [TenderCardDetailsEntryMethod](#type-tendercarddetailsentrymethod) for possible values")
  public EntryMethodEnum getEntryMethod() {
    return entryMethod;
  }

  public void setEntryMethod(EntryMethodEnum entryMethod) {
    this.entryMethod = entryMethod;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TenderCardDetails tenderCardDetails = (TenderCardDetails) o;
    return Objects.equals(this.status, tenderCardDetails.status) &&
        Objects.equals(this.card, tenderCardDetails.card) &&
        Objects.equals(this.entryMethod, tenderCardDetails.entryMethod);
  }

  @Override
  public int hashCode() {
    return Objects.hash(status, card, entryMethod);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TenderCardDetails {\n");
    
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    card: ").append(toIndentedString(card)).append("\n");
    sb.append("    entryMethod: ").append(toIndentedString(entryMethod)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

